<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.4/js/dataTables.bootstrap4.min.js"></script>
  <!-- font awesome -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">



</head>

<body>
  <div class="container">
    <div class="text-center">
      <h3>F100 - QUẢN TRỊ NGƯỜI DÙNG</h3>
    </div>
    <div class="div-filter jumbotron">
      <div class="d-flex h-100 justify-content-around">
        <label class="" for="select-role" style="font-weight: 500;">Role</label>
        <select name="" id="select-role" class="bg-info text-white w-50">
          <option value="0">Chọn một Role</option>
        </select>
        <button id="btn-filter" class="btn btn-success">Lọc dữ liệu</button>
      </div>
    </div>
    <table id="users-table" class="table table-bordered table-striped table-hover table-primary">
      <thead class="text-light" style="font-weight: 500; ">
        <tr>
          <td>STT</td>
          <td>Username</td>
          <td>First name</td>
          <td>Last name</td>
          <td>Email</td>
          <td>Age</td>
          <td>Role</td>
          <td>Action</td>
        </tr>
      </thead>
    </table>
  </div>

</body>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
    {
      id: 2,
      username: "quannv",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      roleId: 5
    },
    {
      id: 3,
      username: "longdh",
      firstname: "Do Hoang",
      lastname: "Long",
      age: 19,
      email: "long@gmail.com",
      roleId: 8
    },
    {
      id: 4,
      username: "hiendt",
      firstname: "Do Thi",
      lastname: "Hien",
      age: 29,
      email: "hien@gmail.com",
      roleId: 11
    },
    {
      id: 6,
      username: "lanht",
      firstname: "Ho Thi",
      lastname: "Lan",
      age: 27,
      email: "lan@gmail.com",
      roleId: 13
    },
    {
      id: 7,
      username: "lanhtt",
      firstname: "Ho Thiee",
      lastname: "Lang",
      age: 28,
      email: "lan@gmail.com",
      roleId: 13
    }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
    {
      roleId: 5,
      roleName: "Admin"
    },
    {
      roleId: 8,
      roleName: "Manager"
    },
    {
      roleId: 11,
      roleName: "Teacher"
    },
    {
      roleId: 13,
      roleName: "Staff"
    }
  ];
  var gSTT = 1;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  $("#btn-filter").on("click", function () {
    var vFilteredUser = gUserObjects.filter(filterByRoleId);
    console.log(vFilteredUser)
    loadDataToTable(vFilteredUser)
  });
  //hàm thực thi nút ấn dice history:
  $("#users-table").on("click", "#btn-dice-history", function () {
    onBtnDiceHistoryClick(this);
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    var vUsersDataTable = $("#users-table").DataTable({
      paging: false,
      lengthChange: false,
      ordering: false,
      searching: false,
      data: gUserObjects,
      columns: [
        { data: "id" },
        { data: "username" },
        { data: "firstname" },
        { data: "lastname" },
        { data: "age" },
        { data: "email" },
        { data: "roleId" },
        { data: "action" },
      ],
      columnDefs: [
        {
          target: 0,
          render: renderSTT
        },
        {
          target: 7,
          "defaultContent": `
          <i id="btn-dice-history" class="fa-solid fa-dice" style="cursor: pointer" data-toggle="tooltip" title="Dice History"></i> 
          <i id="btn-voucher-history" class="fa-solid fa-gift" style="cursor: pointer" data-toggle="tooltip" title="Voucher History"></i>
        
        `
        },
        {
          target: 6,
          render: renderRoleIdToRoleName
        }
      ]
    });
    loadDataToSelect();
  };

  //hàm ấn nút dice history in table:
  function onBtnDiceHistoryClick(paramBtn) {
    var vUserDataTable = $("#users-table").DataTable();
    var vTableRow = $(paramBtn).parents("tr");
    var vDataTableRow = vUserDataTable.row(vTableRow);
    var vUserDataObj = vDataTableRow.data();
    //xử lý chuyển trang sang DiceHistory.html:
    const vDETAIL_FORM_URL = "diceHistory.html";
    var vUrlSiteToOpen = vDETAIL_FORM_URL +
      "?user_name=" + vUserDataObj.username +
      "&first_name=" + vUserDataObj.firstname +
      "&last_name=" + vUserDataObj.lastname;
      window.location.href = vUrlSiteToOpen;
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm render STT: 
  function renderSTT() {
    return gSTT++
  };
  //hàm load data to select role
  function loadDataToSelect() {
    for (let bI = 0; bI < gRoleObjects.length; bI++) {
      $("#select-role").append(`
      <option value="${gRoleObjects[bI].roleId}">${gRoleObjects[bI].roleName}</option>
      `)
    }
  };
  //hàm render role id to role name:
  function renderRoleIdToRoleName(paramData) {
    for (var bI = 0; bI < gRoleObjects.length; bI++) {
      if (gRoleObjects[bI].roleId == paramData) {
        paramData = gRoleObjects[bI].roleName;
        return paramData
      }
    }
  }
  //hàm filter by role ID:
  function filterByRoleId(paramRoleElement) {
    return paramRoleElement.roleId == $("#select-role").val();
  };
  //hàm load data filtered to table:
  function loadDataToTable(paramUserData) {
    var vTable = $("#users-table").DataTable();
    vTable.clear();
    vTable.rows.add(paramUserData);
    vTable.draw();
  }
</script>

</html>